<?php
global $g_days, $g_months, $gv_SiteGlobals, $gv_CalendarGlobals, $gv_CalendarDirectory, $gv_CategoryStyles, $gv_MediaStyles;

$gv_CalendarDirectory = $gv_SiteGlobals['Paths']['FileRoot'] . $gv_SiteGlobals['Paths']['ModulesDir'] . $gv_SiteGlobals["Modules"]['Calendar'];
$gv_CalendarGlobals = parse_ini_file($gv_CalendarDirectory . 'calendar.ini', true);

$gv_CategoryStyles = "";
$gv_MediaStyles = "";

function m_StringToStyleClassName($pv_TheString) {
	$fv_TheString = strtolower($pv_TheString);
	$fv_TheString = str_ireplace(' ', '_', $fv_TheString);
	return $fv_TheString;
}

foreach ($gv_CalendarGlobals['Categories'] as $fv_Index => $fv_Category) {
	$fv_Category = m_StringToStyleClassName($fv_Category);
	$gv_CategoryStyles .= ".$fv_Category, .$fv_Category a{\n";
	$gv_CategoryStyles .= "\tcolor:#{$gv_CalendarGlobals['TextColor'][$fv_Index]} !important;\n";
	$gv_CategoryStyles .= "\tbackground-color:#{$gv_CalendarGlobals['BackgroundColor'][$fv_Index]} !important;\n";
	$gv_CategoryStyles .= "}\n";
	$gv_CategoryStyles .= "text.$fv_Category{\n";
	$gv_CategoryStyles .= "\tfill:#{$gv_CalendarGlobals['TextColor'][$fv_Index]};\n";
	$gv_CategoryStyles .= "}\n";
	$gv_CategoryStyles .= "circle.$fv_Category, line.$fv_Category{\n";
	$gv_CategoryStyles .= "\tfill:#{$gv_CalendarGlobals['BackgroundColor'][$fv_Index]};\n";
	$gv_CategoryStyles .= "}\n";
	$gv_CategoryStyles .= "circle.$fv_Category, line.$fv_Category{\n";
	$gv_CategoryStyles .= "\tstroke:#{$gv_CalendarGlobals['BackgroundColor'][$fv_Index]};\n";
	$gv_CategoryStyles .= "}\n";

    foreach ($gv_CalendarGlobals['MediaType'] as $fv_MIndex => $fv_MediaType) {
		$fv_MediaType = m_StringToStyleClassName($fv_MediaType);
		$gv_MediaStyles .= ".$fv_Category-$fv_MediaType a::before{\n";
		$gv_MediaStyles .= "\tcontent:url('{$gv_CalendarGlobals['Icon'][$fv_MIndex]}={$gv_CalendarGlobals['TextColor'][$fv_Index]}');\n";
		$gv_MediaStyles .= "\tpadding-right: .3em;\n";
		$gv_MediaStyles .= "}\n";
	}
}


foreach ($gv_CalendarGlobals['Days'] as $v_Day) {
	$g_days[] = $v_Day;
}

$g_months[] = '';
foreach ($gv_CalendarGlobals['Months'] as $v_Month) {
	$g_months[] = $v_Month;
}

class maml_calendar extends prototype_tag {

	protected $doctext = <<<'DOCBLOCK'
<p>An empty calendar tag, &lt;maml:calendar /&gt;, will produce a calendar in that location on the page. The user of the calendar can scroll forward or backward through the months. Additionally, based on the setting of the permitted attribute, users can add, edit, and delete events.</p>
<p>A tag with a specified mode with the value "static" is known as a static calendar.  This will be a calendar independent of the other calendars on the page.  This allows for more than one calendar to be on a page but does not allow the user the ability to scroll to the next or previous months.</p>
<p><strong>Calendar Tag Attributes:</strong></p>
<ul>
	<li><strong>permitted:</strong> The permission group allowed to create, edit, and delete events in the calendar.</li>
	<li><strong>size:</strong> Either <em>small</em> or <em>normal</em> (default set in calendar.ini) controls how the calendar is rendered. The small format is a calendar widget where dates with appointments are highlighted. The normal format is a liquid full-size calendar with the events listed on the date they occur.</li>
	<li><strong>showappointments:</strong> When showappointments is set to true, the appointments will show up on the calendar, when it is set to false there will only be an indicator on the number of the day with an event.</li>
	<li><strong>year: </strong>Used together with the <strong>month</strong> to set the initially displayed month. If not set, calendar will display current month. When mode is set to <em>static</em> the user will not be able to change months.</li>
	<li><strong>month:</strong>Used together with the <strong>year</strong> to set the initially displayed month.  If not set, calendar will display current month. When mode is set to <em>static</em> the user will not be able to change months.</li>
	<li><strong>mode:</strong> When mode is set to <em>static</em> the user will not be able to change months. This allows you to display multiple months on a single page instead of requiring the user to switch months.</li>
	<li><strong>id: </strong> Allows you to set an ID for CSS or JavaScript.</li>
	<li><strong>class: </strong> Allows you to set a class for CSS or JavaScript.</li>
	<li><strong>style: </strong> Allows you to override default styles. (Observe generated code to use this effectively and/or adjust the appropriate calendar template(s).</li>
    <li><strong>display: </strong>Allows you to set the initial display to week or month</li>
    <li><strong>week: </strong>Used together with the <strong>month</strong> and <strong>year</strong> to set the initially displayed week when the display is set to week. If not set, calendar will display the first week. When mode is set to <em>static</em> the user will not be able to change weeks.</li>

</ul>
<p>For more information, please see the module documentation.</p>
DOCBLOCK;

	public $permitted;
	public $size;
	public $showappointments;
	public $year;
	public $month;
    public $mode;
    public $week;
    public $display;

	function maml_calendar(){
		$this->emptytag=1;			
	}
	
	public function precheck() {
		// do nothing; <maml:calendar> uses for the permitted attribute for the editor
	}
	
	function begin ($p_FrameColor='', $p_BlankDayColor='', $p_TodayColor='', $p_EventColor='') {
		global $g_months, $g_days, $g_NumDaysinEachMonth, $g_WindoidTitleColor, $g_PageColor, $gv_CalendarGlobals, $gv_CalendarDirectory, $gv_CategoryStyles, $gv_MediaStyles;
        
                $fv_TemplateVars['calborder'] = $gv_CalendarGlobals['Defaults']['CalendarBorder'];
                $fv_TemplateVars['dayborder'] = $gv_CalendarGlobals['Defaults']['DayBorder'];
                $fv_TemplateVars['labelborder'] = $gv_CalendarGlobals['Defaults']['LabelBorder'];
                $fv_TemplateVars['monthbackground'] = $gv_CalendarGlobals['Defaults']['MonthBackground'];
                $fv_TemplateVars['daybackground'] = $gv_CalendarGlobals['Defaults']['DayBackground'];
                $fv_TemplateVars['labelbackground'] = $gv_CalendarGlobals['Defaults']['LabelBackground'];
        
		if (!isset($this->size)){
			$this->size = $gv_CalendarGlobals['Defaults']['Size'];
		} else {
        	$this->size =strtolower($this->size);
        }
        $fv_TemplateVars['sizeId'] = $this->size;

		if (!isset($this->showappointments)){
			$this->showappointments = $gv_CalendarGlobals['Defaults']['ShowAppointments'];
		} else {
            $this->showappointments =strtoupper($this->showappointments);

        }
        

	// # Default Values #
	$fv_TemplateVars['thisPage'] = basename($_SERVER['SCRIPT_FILENAME']);
				if ($this->style) {
					$fv_TemplateVars['style'] = ' style="' . $this->style . '"';
				}
	
	if(!isset($_REQUEST['t_CurrentCalendarMode'])) {
//		$_REQUEST['t_CurrentCalendarMode']='month_view';
        
        if (isset($this->display)){
        $this->display =strtolower($this->display);
            $_REQUEST['t_CurrentCalendarMode']=$this->display."_view";
		} else {
            $this->display = $gv_CalendarGlobals['Defaults']['Display'];
            $_REQUEST['t_CurrentCalendarMode']=$this->display."_view";


        }
	}
	$fv_TemplateVars['CurrentCalendarMode'] = $_REQUEST['t_CurrentCalendarMode'];
        if(!isset($fv_TemplateVars['CalMode'])) {

        if (!isset($this->mode)){
			$this->mode = "default";
            	$fv_TemplateVars['CalMode'] = $this->mode ;
		} else {
            	$fv_TemplateVars['CalMode'] = $this->mode ;

        }
    }
        if ($fv_TemplateVars['CalMode'] == "static"){
            $fv_TemplateVars['leftArrow']= "";
            $fv_TemplateVars['rightArrow']="";

		} else {
            if ($_REQUEST['t_CurrentCalendarMode']=="month_view") {

            $fv_TemplateVars['leftArrow']='<div class="molly_calendar_arrow"><a href="?t_CurrentCalendarMode=month_view&t_SelectedCalendarYear=*[prevYear]*&t_SelectedCalendarMonth=*[prevMonth]*">'.$gv_CalendarGlobals['Defaults']['LeftArrowSymbol'].'</a></div>';
            $fv_TemplateVars['rightArrow']='<div class="molly_calendar_arrow"><a href="?t_CurrentCalendarMode=month_view&t_SelectedCalendarYear=*[nextYear]*&t_SelectedCalendarMonth=*[nextMonth]*">'.$gv_CalendarGlobals['Defaults']['RightArrowSymbol'].'</a></div>';
            } elseif($_REQUEST['t_CurrentCalendarMode']=="week_view") {

                $fv_TemplateVars['leftArrow']='<div class="molly_calendar_arrow"><a href="?t_CurrentCalendarMode=week_view&t_SelectedCalendarYear=*[prevYear]*&t_SelectedCalendarMonth=*[prevMonth]*&t_SelectedCalendarWeek=*[prevWeek]*">'.$gv_CalendarGlobals['Defaults']['LeftArrowSymbol'].'</a></div>';
            $fv_TemplateVars['rightArrow']='<div class="molly_calendar_arrow"><a href="?t_CurrentCalendarMode=week_view&t_SelectedCalendarYear=*[nextYear]*&t_SelectedCalendarMonth=*[nextMonth]*&t_SelectedCalendarWeek=*[nextWeek]*">'.$gv_CalendarGlobals['Defaults']['RightArrowSymbol'].'</a></div>';   
            } elseif($_REQUEST['t_CurrentCalendarMode']=="day_view") {

                $fv_TemplateVars['leftArrow']='<div class="molly_calendar_arrow"><a href="?t_CurrentCalendarMode=day_view&t_SelectedCalendarYear=*[prevYear]*&t_SelectedCalendarMonth=*[prevMonth]*&t_SelectedCalendarDay=*[prevDay]*">'.$gv_CalendarGlobals['Defaults']['LeftArrowSymbol'].'</a></div>';
            $fv_TemplateVars['rightArrow']='<div class="molly_calendar_arrow"><a href="?t_CurrentCalendarMode=day_view&t_SelectedCalendarYear=*[nextYear]*&t_SelectedCalendarMonth=*[nextMonth]*&t_SelectedCalendarDay=*[nextDay]*">'.$gv_CalendarGlobals['Defaults']['RightArrowSymbol'].'</a></div>';   
            }
        }
        

        
        
    if($fv_TemplateVars['CalMode'] == "static"){
        $_REQUEST['t_SelectedCalendarYear'] = $this->year;
        if (!isset($this->year)) {
            $_REQUEST['t_SelectedCalendarYear'] = date("Y");
        }
    } else {
	if(!isset($_REQUEST['t_SelectedCalendarYear'])) {
		if (isset($this->year)) {
			$_REQUEST['t_SelectedCalendarYear'] = $this->year;
		} else {
			$_REQUEST['t_SelectedCalendarYear'] = date("Y");
		}
	}
    }
	$fv_TemplateVars['SelectedCalendarYear'] = $_REQUEST['t_SelectedCalendarYear'];
    
    if($fv_TemplateVars['CalMode'] == "static"){
    
         $_REQUEST['t_SelectedCalendarMonth'] = $this->month;      
        if (!isset($this->month)) {
            $_REQUEST['t_SelectedCalendarMonth'] = date("n");

        }

    } else {
	if(!isset($_REQUEST['t_SelectedCalendarMonth'])) { 
		if (isset($this->month)) {
			$_REQUEST['t_SelectedCalendarMonth'] = $this->month;
		} else {
			$_REQUEST['t_SelectedCalendarMonth'] = date("n");
		}
	}
    }
	$fv_TemplateVars['SelectedCalendarMonth'] = $_REQUEST['t_SelectedCalendarMonth'];
        
        
	   if($fv_TemplateVars['CalMode'] == "static"){
    
         $_REQUEST['t_SelectedCalendarWeek'] = $this->week;      
        if (!isset($this->week)) {
            $_REQUEST['t_SelectedCalendarWeek'] = $gv_CalendarGlobals['Defaults']['Week'];

        }

    } else {
	if(!isset($_REQUEST['t_SelectedCalendarWeek'])) { 
		if (isset($this->week)) {
			$_REQUEST['t_SelectedCalendarWeek'] = $this->week;
		} else {
			$_REQUEST['t_SelectedCalendarWeek'] = $gv_CalendarGlobals['Defaults']['Week'];
		}
	}
    }
        
        
        
	$fv_TemplateVars['SelectedCalendarMonth'] = $_REQUEST['t_SelectedCalendarMonth'];
	if(!isset($_REQUEST['t_SelectedCalendarDay'])) { 
		$_REQUEST['t_SelectedCalendarDay'] = date("j");
	}
	$fv_TemplateVars['SelectedCalendarDay'] = $_REQUEST['t_SelectedCalendarDay'];
	
	
	// number of days in each month
	$g_NumDaysinEachMonth = array(0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);

	// if leap year, modify $g_NumDaysinEachMonth array appropriately
	if (date("L", m_MakeUnixTimestampGMT(0,0,0,$_SESSION['s_SelectedCalendarMonth'],1,$_SESSION['s_SelectedCalendarYear']))) {
		$g_NumDaysinEachMonth[2] = 29;
	}
		if (!$p_FrameColor) {
			global $g_WindoidFrameColor;
			$p_FrameColor=$g_WindoidFrameColor;
		}
		
		if (!$p_BlankDayColor) {
			global $g_FormMedium;
			$p_BlankDayColor=$g_FormMedium;
		}
		
		if (!$p_TodayColor) {
			global $g_LightGreen;
			$p_TodayColor=$g_LightGreen;
		}
		
		if (!$p_EventColor) {
			global $g_LightYellow;
			$p_EventColor=$g_LightYellow;
		}
		
		switch ($_REQUEST['t_CurrentCalendarMode']) {
			case "month_view":
                if ($this->showappointments == "FALSE"){
                    $fv_TemplateVars['appointClass'] = 'hideAppt';

                } else {
                    $fv_TemplateVars['appointClass'] = 'showAppt';

                }
				// defaults for previous month
				$v_prevMonth = $_REQUEST['t_SelectedCalendarMonth']-1;
				$v_prevYear = $_REQUEST['t_SelectedCalendarYear'];
				
				// if January, decrement year and set month to December
				if ($v_prevMonth < 1) {
					$v_prevMonth = 12;
					$v_prevYear--;
				}	
				$fv_TemplateVars['prevMonth'] = $v_prevMonth;
				$fv_TemplateVars['prevYear'] = $v_prevYear;
				
				// defaults for next month
				$v_nextMonth = $_REQUEST['t_SelectedCalendarMonth']+1;
				$v_nextYear = $_REQUEST['t_SelectedCalendarYear'];
				
				// if December, increment year and set month to January
				if ($v_nextMonth > 12) {
					$v_nextMonth = 1;
					$v_nextYear++;
				}	
				$fv_TemplateVars['nextMonth'] = $v_nextMonth;
				$fv_TemplateVars['nextYear'] = $v_nextYear;
				
				// get down to displaying the calendar
				// find out which day the first of the month falls on
				$v_firstDayOfMonth = date("w", m_MakeUnixTimestampGMT(0,0,0,$_REQUEST['t_SelectedCalendarMonth'],1,$_REQUEST['t_SelectedCalendarYear']));
				
				$v_rows=m_FetchRecordsArray("molly_calendar","mc_date","mc_date >= '".m_MakeUnixTimestampGMT(0, 0, 0, sprintf("%02d", $_REQUEST['t_SelectedCalendarMonth']) ,01,   $_REQUEST['t_SelectedCalendarYear'] )."' AND mc_date <= '" .m_MakeUnixTimestampGMT(0, 0, 0, sprintf("%02d", $_REQUEST['t_SelectedCalendarMonth']) , $g_NumDaysinEachMonth[$_REQUEST['t_SelectedCalendarMonth']],$_REQUEST['t_SelectedCalendarYear']  ). "'","");
				
				$v_x=0;
				$v_dateList=array();
				if(count($v_rows) > 0) {
					for($i=0;$i<count($v_rows);$i++){
						$v_dates = explode("-",m_DateGMT($v_rows[$i]["mc_date"]));
						$v_dateList[$v_x] = $v_dates[1];
						$v_x++;
					}
				
				}

				$fv_TemplateVars['monthName'] = $g_months[$_REQUEST['t_SelectedCalendarMonth']];
				
				for ($v_x=0; $v_x<7; $v_x++) {
					$v_Day = "Day_$v_x";
					$fv_TemplateVars[$v_Day] = $g_days[$v_x];
				}

                
                $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.begin.tplt', $fv_TemplateVars);
				
				$fv_TemplateVars['dayType'] = 'day';
				
				for ($v_x=1; $v_x<=$v_firstDayOfMonth; $v_x++) { // Blank days at beginning of month
					$v_rowCount++;
					//echo "<td bgcolor = \"$p_BlankDayColor\">&nbsp;</td>";
					$fv_TemplateVars['date'] = '&nbsp;';
					$fv_TemplateVars['dayType'] = 'day blank';
					$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.day.tplt', $fv_TemplateVars);
                    $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.day.end.tplt', $fv_TemplateVars);

				}
				
				$v_dayCount=1;

				while ($v_dayCount <= $g_NumDaysinEachMonth[$_REQUEST['t_SelectedCalendarMonth']]) {
				
                $v_this_date = m_MakeUnixTimestampGMT(0,0,0, sprintf("%02d", $_REQUEST['t_SelectedCalendarMonth']) , sprintf("%02d", $v_dayCount),$_REQUEST['t_SelectedCalendarYear'] );
                
                $v_this_date_end = m_MakeUnixTimestampGMT(23,59,59, sprintf("%02d", $_REQUEST['t_SelectedCalendarMonth']) , sprintf("%02d", $v_dayCount),$_REQUEST['t_SelectedCalendarYear'] );
                
				$v_rows=m_FetchRecordsArray("molly_calendar","*","mc_date>='$v_this_date' AND mc_date <='$v_this_date_end'","mc_date");
				$eventString="";
                $fv_TemplateVars['dayType'] = 'day';
				if ($v_dayCount == date("j") && $_REQUEST['t_SelectedCalendarYear'] == date("Y") && $_REQUEST['t_SelectedCalendarMonth'] == date("n")) {
					$fv_TemplateVars['dayType'] .= ' isToday';
				}
				$fv_TemplateVars['date'] = $v_dayCount;
				
                if(count($v_rows) >0) {
                    $fv_TemplateVars['dayType'] = 'day hasEvent';
                    if ($v_dayCount == date("j") && $_REQUEST['t_SelectedCalendarYear'] == date("Y") && $_REQUEST['t_SelectedCalendarMonth'] == date("n")) {
						$fv_TemplateVars['dayType'] .= ' isToday';
					}
	               $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.day.tplt', $fv_TemplateVars);
                   
				    for($i=0;$i<count($v_rows);$i++){
                    	$fv_TemplateVars['catStyle'] = m_StringToStyleClassName($v_rows[$i]["mc_category"]);
                        $fv_TemplateVars['mediaStyle']= $fv_TemplateVars['catStyle']."-".m_StringToStyleClassName($v_rows[$i]["mc_media_type"]);
                        
                        
                        $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.monthEvent.begin.tplt', $fv_TemplateVars);					
                        $fv_TemplateVars['eventTitle']= $v_rows[$i]["mc_title"];
                        $fv_TemplateVars['eventUrl']= $v_rows[$i]["mc_url"];

                        $url = $v_rows[$i]["mc_url"];
                        if (!($url == null || $url == "No information")){
                            $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.monthEvent.link.tplt', $fv_TemplateVars);					
                        } else {
                            $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.monthEvent.noLink.tplt', $fv_TemplateVars);					
						}
						$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.monthEvent.end.tplt', $fv_TemplateVars);					
                    }
				} else {
	               $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.day.tplt', $fv_TemplateVars);
                }
				$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.day.end.tplt', $fv_TemplateVars);
				$v_dayCount++;
				$v_rowCount++;
				}
				
				while ($v_rowCount % 7 != 0) { //blank days at end of month
					$fv_TemplateVars['date'] = '&nbsp;';
					$fv_TemplateVars['dayType'] = 'day blank';
					$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.day.tplt', $fv_TemplateVars);
                    $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.day.end.tplt', $fv_TemplateVars);

					$v_rowCount++;
				}
				$fv_TemplateVars['year'] = $_REQUEST['t_SelectedCalendarYear'];
                $fv_TemplateVars['month'] = $_REQUEST['t_SelectedCalendarMonth'];


				$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.end.tplt', $fv_TemplateVars);
				
			break; //month_view
                
            case "week_view":
                if ($this->showappointments == "FALSE"){
                    $fv_TemplateVars['appointClass'] = 'hideAppt';
                } else {
                    $fv_TemplateVars['appointClass'] = 'showAppt';
                }
                if($_REQUEST['t_SelectedCalendarMonth']==1){
                    $_prevMonth=12;
                }
                else{
                    $_prevMonth=$_REQUEST['t_SelectedCalendarMonth']-1;
                }
                $prevNumWeeks= $this->m_NumWeeksInMonth($_prevMonth);
           

				// defaults for previous month
                $v_prevWeek = $_REQUEST['t_SelectedCalendarWeek']-1;

				$v_prevMonth = $_REQUEST['t_SelectedCalendarMonth'];
				$v_prevYear = $_REQUEST['t_SelectedCalendarYear'];
				
				// if January, decrement year and set month to December
                if ($v_prevWeek < 1) {
					$v_prevWeek = $prevNumWeeks;
					$v_prevMonth--;
				}
                
				if ($v_prevMonth < 1) {
					$v_prevMonth = 12;
					$v_prevYear--;
				}	
                $fv_TemplateVars['prevWeek'] = $v_prevWeek;

				$fv_TemplateVars['prevMonth'] = $v_prevMonth;
				$fv_TemplateVars['prevYear'] = $v_prevYear;
				
				// defaults for next month
                $v_nextWeek = $_REQUEST['t_SelectedCalendarWeek']+1;

				$v_nextMonth = $_REQUEST['t_SelectedCalendarMonth'];
				$v_nextYear = $_REQUEST['t_SelectedCalendarYear'];
				
				// CHECK TO SEE HOW MANY WEEKS IN CURRENT MONTH
                     $curNumWeeks= $this->m_NumWeeksInMonth($_REQUEST['t_SelectedCalendarMonth']);
                
                	if ($v_nextWeek > $curNumWeeks) {
					$v_nextWeek = 1;
					$v_nextMonth++;
				}	
				if ($v_nextMonth > 12) {
					$v_nextMonth = 1;
					$v_nextYear++;
				}	
                $fv_TemplateVars['nextWeek'] = $v_nextWeek;

				$fv_TemplateVars['nextMonth'] = $v_nextMonth;
				$fv_TemplateVars['nextYear'] = $v_nextYear;
				
				// get down to displaying the calendar
				// find out which day the first of the month falls on
				$v_firstDayOfMonth = date("w", m_MakeUnixTimestampGMT(0,0,0,$_REQUEST['t_SelectedCalendarMonth'],1,$_REQUEST['t_SelectedCalendarYear']));
			
				$v_rows=m_FetchRecordsArray("molly_calendar","mc_date","mc_date >= '".m_MakeUnixTimestampGMT(0, 0, 0, sprintf("%02d", $_REQUEST['t_SelectedCalendarMonth']) ,01,   $_REQUEST['t_SelectedCalendarYear'] )."' AND mc_date <= '" .m_MakeUnixTimestampGMT(0, 0, 0, sprintf("%02d", $_REQUEST['t_SelectedCalendarMonth']) , $g_NumDaysinEachMonth[$_REQUEST['t_SelectedCalendarMonth']],$_REQUEST['t_SelectedCalendarYear']  ). "'","");
				

				$fv_TemplateVars['monthName'] = $g_months[$_REQUEST['t_SelectedCalendarMonth']];
				for ($v_x=0; $v_x<7; $v_x++) {
					$v_Day = "Day_$v_x";
					$fv_TemplateVars[$v_Day] = $g_days[$v_x];
				}
                $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.weekview.begin.tplt', $fv_TemplateVars);
				$fv_TemplateVars['dayType'] = 'weekday';
                
                //If the selected week is the first week of the month, then put blank days in front 
                if($_REQUEST['t_SelectedCalendarWeek']=="1"){
				for ($v_x=1; $v_x<=$v_firstDayOfMonth; $v_x++) { // Blank days at beginning of month
					$v_rowCount++;
					$fv_TemplateVars['date'] = '&nbsp;';
					$fv_TemplateVars['dayType'] = 'weekday blank';
                    $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.weekview.day.begin.tplt', $fv_TemplateVars);
                    $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.weekview.day.end.tplt', $fv_TemplateVars);
				}
                }
                
                $v_dayCount1=1;
                $v_dayArray=array();
                //while the day count is less than the number of days in each month of the selected month,add to a day of week array 
                while ($v_dayCount1 <= $g_NumDaysinEachMonth[$_REQUEST['t_SelectedCalendarMonth']]) {
                    $v_dayOfWeek = date("w", m_MakeUnixTimestampGMT(0,0,0,$_REQUEST['t_SelectedCalendarMonth'],$v_dayCount1,$_REQUEST['t_SelectedCalendarYear']));
                    $v_dayArray[] = $v_dayOfWeek;
				    $v_dayCount1++;
                }
                
                $days_count = array_count_values($v_dayArray);
                $num_of_6s = $days_count[6]; 
                $weeksArray = array();
                $oldSunday=0;
                $dayNum=1;

                for ($num6=1; $num6<=$num_of_6s; $num6++) {
                    $sunday= array_search("6",$v_dayArray);
                    $daysInWeek = $sunday-$oldSunday +1;
                    $v_thisWeek= array_slice($v_dayArray,$oldSunday,$daysInWeek);
                    $v_dayArray= array_slice($v_dayArray,$sunday+1);
                    $weekString= "week".$num6;
                    $weeksArray[$weekString] = $v_thisWeek;
                    array_unshift($weeksArray[$weekString],$dayNum);
                    
                    $dayNum=$dayNum+$daysInWeek;


                }
                $newNum=$num_of_6s+1;
                $weekString= "week".$newNum;
                $weeksArray[$weekString]=$v_dayArray;
                array_unshift($weeksArray[$weekString],$dayNum);
                $thisWeek= "week".$_REQUEST['t_SelectedCalendarWeek'];
                $v_dayCount= $weeksArray[$thisWeek][0];
                for($j=1; $j<count($weeksArray[$thisWeek]); $j++) {
                    $fv_TemplateVars['dayType'] = 'weekday';
                    $fv_TemplateVars['date'] = $v_dayCount;
                    $v_this_date = m_MakeUnixTimestampGMT(0,0,0, sprintf("%02d", $_REQUEST['t_SelectedCalendarMonth']) , sprintf("%02d", $v_dayCount),$_REQUEST['t_SelectedCalendarYear'] );
                    $v_this_date_end = m_MakeUnixTimestampGMT(23,59,59, sprintf("%02d", $_REQUEST['t_SelectedCalendarMonth']) , sprintf("%02d", $v_dayCount),$_REQUEST['t_SelectedCalendarYear'] );
				    $v_rows=m_FetchRecordsArray("molly_calendar","*","mc_date>='$v_this_date' AND mc_date <='$v_this_date_end'","mc_date");
				    $eventString="";
                    if ($v_dayCount == date("j") && $_REQUEST['t_SelectedCalendarYear'] == date("Y") && $_REQUEST['t_SelectedCalendarMonth'] == date("n")) {
                        $fv_TemplateVars['dayType'] .= ' isToday';
				    }
                    
                    
                    if(count($v_rows) >0) {
                    $fv_TemplateVars['dayType'] = 'weekday hasEvent';
                        if ($v_dayCount == date("j") && $_REQUEST['t_SelectedCalendarYear'] == date("Y") && $_REQUEST['t_SelectedCalendarMonth'] == date("n")) {
						  $fv_TemplateVars['dayType'] .= ' isToday';
					   }
                    $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.weekview.day.begin.tplt', $fv_TemplateVars);
    				    for($i=0;$i<count($v_rows);$i++){
                    	$fv_TemplateVars['catStyle'] = m_StringToStyleClassName($v_rows[$i]["mc_category"]);
                        $fv_TemplateVars['mediaStyle']= $fv_TemplateVars['catStyle']."-".m_StringToStyleClassName($v_rows[$i]["mc_media_type"]);
                        $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.weekEvent.begin.tplt', $fv_TemplateVars);					
                        $fv_TemplateVars['eventTitle']= $v_rows[$i]["mc_title"];
                        $fv_TemplateVars['eventUrl']= $v_rows[$i]["mc_url"];
			             $fv_TemplateVars['thisTime'] = m_TimeGMT($v_rows[$i]["mc_date"]);
                        $url = $v_rows[$i]["mc_url"];
                        if (!($url == null || $url == "No information")){
                          $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.weekEvent.link.tplt', $fv_TemplateVars);					
                       } else {
                            $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.weekEvent.noLink.tplt', $fv_TemplateVars);					
					}
						$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.weekEvent.end.tplt', $fv_TemplateVars);					
                    }
 
                        
                    }else {
                    $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.weekview.day.begin.tplt', $fv_TemplateVars);

                    }
                    $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.weekview.day.end.tplt', $fv_TemplateVars);
                    $v_dayCount++;

                }

                if($_REQUEST['t_SelectedCalendarWeek']==count($weeksArray)){
                     $thisWeek= "week".$_REQUEST['t_SelectedCalendarWeek'];
                    $v_rowCount =count($weeksArray[$thisWeek])-1;
				while ($v_rowCount % 7 != 0) { //blank days at end of month
					$fv_TemplateVars['date'] = '&nbsp;';
					$fv_TemplateVars['dayType'] = 'weekday blank';
                   $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.weekview.day.begin.tplt', $fv_TemplateVars);
                   $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.weekview.day.end.tplt', $fv_TemplateVars);

					$v_rowCount++;
				}
                }
                	$fv_TemplateVars['year'] = $_REQUEST['t_SelectedCalendarYear'];
                $fv_TemplateVars['month'] = $_REQUEST['t_SelectedCalendarMonth'];
				$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.weekview.end.tplt', $fv_TemplateVars);
                
            break;
               
                
                
                
                
			case "day_view":

                	if(isset($_REQUEST['StatusMessage'])) {
                        if ($_REQUEST['StatusMessage'] == "EditSuccess"){
                            $fv_TemplateVars['StatusMessage'] = "Event Edited Successfully";
                        } else if ($_REQUEST['StatusMessage'] == "AddSuccess"){
                             $fv_TemplateVars['StatusMessage'] = "Event Added Successfully";
                        } else if ($_REQUEST['StatusMessage'] == "DeleteSuccess"){
                             $fv_TemplateVars['StatusMessage'] = "Event Deleted Successfully";
                        }

                    }
                
                 if($_REQUEST['t_SelectedCalendarMonth']==1){
                    $_prevMonth=12;
                }
                else{
                    $_prevMonth=$_REQUEST['t_SelectedCalendarMonth']-1;
                }
                //$prevNumWeeks= $this->m_NumWeeksInMonth($_prevMonth);
           				$v_numDaysInMonth = date("t", m_MakeUnixTimestampGMT(0,0,0,$_prevMonth,$_REQUEST['t_SelectedCalendarDay'],$_REQUEST['t_SelectedCalendarYear']));

				// defaults for previous month
                $v_prevDay = $_REQUEST['t_SelectedCalendarDay']-1;

				$v_prevMonth = $_REQUEST['t_SelectedCalendarMonth'];
				$v_prevYear = $_REQUEST['t_SelectedCalendarYear'];
				
				// if January, decrement year and set month to December
                if ($v_prevDay < 1) {
					$v_prevDay = $v_numDaysInMonth;
					$v_prevMonth--;
				}
                
				if ($v_prevMonth < 1) {
					$v_prevMonth = 12;
					$v_prevYear--;
				}	
                $fv_TemplateVars['prevDay'] = $v_prevDay;

				$fv_TemplateVars['prevMonth'] = $v_prevMonth;
				$fv_TemplateVars['prevYear'] = $v_prevYear;
				
				// defaults for next month
                $v_nextDay= $_REQUEST['t_SelectedCalendarDay']+1;

				$v_nextMonth = $_REQUEST['t_SelectedCalendarMonth'];
				$v_nextYear = $_REQUEST['t_SelectedCalendarYear'];
				
				// CHECK TO SEE HOW MANY WEEKS IN CURRENT MONTH
                  //   $curNumWeeks= $this->m_NumWeeksInMonth($_REQUEST['t_SelectedCalendarMonth']);
                    $v_curNumDays = date("t", m_MakeUnixTimestampGMT(0,0,0,$_REQUEST['t_SelectedCalendarMonth'],$_REQUEST['t_SelectedCalendarDay'],$_REQUEST['t_SelectedCalendarYear']));

                if ($v_nextDay < $curNumDays) {
					$v_nextDay = 1;
					$v_nextMonth++;
				}	
				if ($v_nextMonth > 12) {
					$v_nextMonth = 1;
					$v_nextYear++;
				}	
                $fv_TemplateVars['nextDay'] = $v_nextDay;

				$fv_TemplateVars['nextMonth'] = $v_nextMonth;
				$fv_TemplateVars['nextYear'] = $v_nextYear;
				
                
                
                
                
                
                
                
                
				// format date for entry into database
                if ($_REQUEST['t_SelectedCalendarMonth']==$_GET['t_SelectedCalendarMonth'] && $_REQUEST['t_SelectedCalendarDay']==$_GET['t_SelectedCalendarDay'] && $_REQUEST['t_SelectedCalendarYear'] == $_GET['t_SelectedCalendarYear']){
                    
                    
					$v_this_date = m_MakeUnixTimestampGMT(0,0,0, sprintf("%02d", $_GET['t_SelectedCalendarMonth']) , sprintf("%02d", $_GET['t_SelectedCalendarDay']),$_GET['t_SelectedCalendarYear'] );
					$v_this_date_end = m_MakeUnixTimestampGMT(23,59,59, sprintf("%02d", $_GET['t_SelectedCalendarMonth']) , sprintf("%02d", $_GET['t_SelectedCalendarDay']),$_GET['t_SelectedCalendarYear'] );
				
					if (m_permitted($this->permitted)) {
						$fv_TemplateVars['colspan'] = 4;

					} else {
						$fv_TemplateVars['colspan'] = 3;
					}
					$fv_TemplateVars['monthName'] = $g_months[$_GET['t_SelectedCalendarMonth']];
                
					$selectedDate = date("D M d Y", m_MakeUnixTimestampGMT(0,0,0,$_GET['t_SelectedCalendarMonth'],$_GET['t_SelectedCalendarDay'],$_GET['t_SelectedCalendarYear']));
					$dateArr = explode(' ', $selectedDate, 3);
					$dayToTranslate = $dateArr[0];
					$fv_DayNameArray = array ('Sun', 'Mon', 'Tues', 'Wed', 'Thu', 'Fri', 'Sat');
					$fv_DayIndex = array_search ($dayToTranslate, $fv_DayNameArray);
					$fv_TemplateVars['dayOfWeekDate'] = $g_days[$fv_DayIndex];
				
					$monthToTranslate = $dateArr[1];
					$fv_MonthNameArray = array ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov','Dec');
					$fv_MonthIndex = array_search ($monthToTranslate, $fv_MonthNameArray);
					$fv_thisMonth = $g_months[$fv_MonthIndex + 1];
				
					$fv_TemplateVars['selectedDate'] = $fv_thisMonth ." ". $dateArr[2];
    
                    
                    
                    

                      $v_dayCount1=1;
                $v_dayArray=array();
                //while the day count is less than the number of days in each month of the selected month,add to a day of week array 
                while ($v_dayCount1 <= $g_NumDaysinEachMonth[$_REQUEST['t_SelectedCalendarMonth']]) {
                    $v_dayOfWeek = date("w", m_MakeUnixTimestampGMT(0,0,0,$_REQUEST['t_SelectedCalendarMonth'],$v_dayCount1,$_REQUEST['t_SelectedCalendarYear']));
                    $v_dayArray[] = $v_dayOfWeek;
				    $v_dayCount1++;
                }
                
                $days_count = array_count_values($v_dayArray);
                $num_of_6s = $days_count[6]; 
                $weeksArray = array();
                $oldSunday=0;
                $dayNum=1;

                for ($num6=1; $num6<=$num_of_6s; $num6++) {
                    $sunday= array_search("6",$v_dayArray);
                    $daysInWeek = $sunday-$oldSunday +1;
                    $v_dayArray= array_slice($v_dayArray,$sunday+1);
                    $weeksArray[]=$dayNum;
                    $dayNum=$dayNum+$daysInWeek;
                }
                $newNum=$num_of_6s+1;
                $weeksArray[]=$dayNum;
             $weekNum=1;
                    $day=intval($_REQUEST['t_SelectedCalendarDay']);
                    for ($i=0; $i<count($weeksArray); $i++) {
                        if ($day>=$weeksArray[$i]){
                            $weekNum=$i+1;
                        }
                    }
                    
                    $fv_TemplateVars['SelectedCalendarWeek'] = $weekNum;
					$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.viewday.begin.tplt', $fv_TemplateVars);	

					$v_query = "SELECT * FROM molly_calendar WHERE mc_date>='$v_this_date' AND mc_date <='$v_this_date_end' ORDER BY mc_date";
					$v_rows=m_FetchRecordsArray("molly_calendar","*","mc_date>='$v_this_date' AND mc_date <='$v_this_date_end'","mc_date");
					if(count($v_rows) >0) {
						// get the list of appointments
				
						for($i=0;$i<count($v_rows);$i++){
							$fv_TemplateVars['thisTime'] = m_TimeGMT($v_rows[$i]["mc_date"]);
							$fv_TemplateVars['eventTitle'] = htmlspecialchars($v_rows[$i]["mc_title"]);
							$fv_TemplateVars['eventDescription'] = htmlspecialchars($v_rows[$i]["mc_description"]);
							$fv_TemplateVars['CalendarEventID'] = $v_rows[$i]["mc_id"];
                            $fv_TemplateVars['catStyle'] = m_StringToStyleClassName($v_rows[$i]["mc_category"]);
							
							if (m_permitted($this->permitted)) {
								$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.editable_event.tplt', $fv_TemplateVars);	
							} else {
								$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.event.tplt', $fv_TemplateVars);	
							}
						}
					} else {
						$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.nothing_scheduled.tplt', $fv_TemplateVars);
					}
				
					if (m_permitted($this->permitted)) {
						$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.viewday_editable.end.tplt', $fv_TemplateVars);
					} else {
						$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.viewday.end.tplt', $fv_TemplateVars);
					} 
                }
 			break; //day_view
			
			case "timeline_horizontal_view":
                $v_rows=m_FetchRecordsArray("molly_calendar","*","1=1","");
				
				if(count($v_rows) > 0) {
					$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.timeline-horizontal.begin.tplt', $fv_TemplateVars);
					
					for($i = 0; $i < count($v_rows); $i++) {
						$fv_TemplateVars["mc_title"] = addslashes($v_rows[$i]["mc_title"]);
						$fv_TemplateVars["mc_url"] = $v_rows[$i]["mc_url"]; // TODO: need to handle for no link, iframe_content
						$fv_TemplateVars["mc_tooltip"] = addslashes($v_rows[$i]["mc_category"] . "<br />" . $v_rows[$i]["mc_description"]);
						$fv_TemplateVars["mc_date"] = $v_rows[$i]["mc_date"] * 1000;
						$fv_TemplateVars["mc_class"] = m_StringToStyleClassName($v_rows[$i]["mc_category"]);
						$fv_TemplateVars["mc_media_class"] = m_StringToStyleClassName($v_rows[$i]["mc_category"]) . "-" . strtolower($v_rows[$i]["mc_media_type"]); // will soft-default to "" if none
						if($fv_TemplateVars["mc_url"] == null || $fv_TemplateVars["mc_url"] == "No information") {
							$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.timeline-horizontal.event-nolink.tplt', $fv_TemplateVars);
						} else {
							$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.timeline-horizontal.event.tplt', $fv_TemplateVars);
						}
					}
					
					$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.timeline-horizontal.end.tplt', $fv_TemplateVars);
				} else {
					$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.timeline.empty.tplt', $fv_TemplateVars);
				}
				
			break; //timeline_view_horizontal
			
			case "timeline_horizontal_grouped_view":
                $v_rows=m_FetchRecordsArray("molly_calendar","*","1=1","");
				
				if(count($v_rows) > 0) {
					$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.timeline-horizontal-grouped.begin.tplt', $fv_TemplateVars);
					
					for($i = 0; $i < count($v_rows); $i++) {
						$fv_TemplateVars["mc_title"] = addslashes($v_rows[$i]["mc_title"]);
						$fv_TemplateVars["mc_url"] = $v_rows[$i]["mc_url"]; // TODO: need to handle for no link, iframe_content
						$fv_TemplateVars["mc_tooltip"] = addslashes($v_rows[$i]["mc_category"] . "<br />" . $v_rows[$i]["mc_description"]);
						$fv_TemplateVars["mc_date"] = $v_rows[$i]["mc_date"] * 1000;
						$fv_TemplateVars["mc_class"] = m_StringToStyleClassName($v_rows[$i]["mc_category"]);
						$fv_TemplateVars["mc_media_class"] = m_StringToStyleClassName($v_rows[$i]["mc_category"]) . "-" . strtolower($v_rows[$i]["mc_media_type"]); // will soft-default to "" if none
						if($fv_TemplateVars["mc_url"] == null || $fv_TemplateVars["mc_url"] == "No information") {
							$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.timeline-horizontal-grouped.event-nolink.tplt', $fv_TemplateVars);
						} else {
							$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.timeline-horizontal-grouped.event.tplt', $fv_TemplateVars);
						}
					}
					
					$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.timeline-horizontal-grouped.middle.tplt', $fv_TemplateVars);
					
					foreach ($gv_CalendarGlobals['Categories'] as $fv_Index => $fv_Category) {
						$fv_TemplateVars["cat_slug"] = $fv_Category;
						$fv_TemplateVars["cat_slug"] = m_StringToStyleClassName($fv_Category);
						$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.timeline-horizontal-grouped.group.tplt', $fv_TemplateVars);
					}
					
					$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.timeline-horizontal-grouped.end.tplt', $fv_TemplateVars);
				} else {
					$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.timeline.empty.tplt', $fv_TemplateVars);
				}
				
			break; //timeline_view_horizontal_grouped
			
			case "timeline_view_vertical":
				$v_rows=m_FetchRecordsArray("molly_calendar","*","1=1","");
				
				if(count($v_rows) > 0) {
					$fv_FirstTime = $v_rows[0]["mc_date"]; // "if(count($v_rows) > 0)" (above) asserts at least index 0 exists
					$fv_LastTime = $v_rows[count($v_rows) - 1]["mc_date"];
					
					$fv_TemplateVars["height"] = ($fv_LastTime - $fv_FirstTime) * $gv_CalendarGlobals['Defaults']['VerticalTimelineScale'] + $gv_CalendarGlobals['Defaults']['VerticalTimelineBottomPadding'];
					$fv_TemplateVars["topMargin"] = $gv_CalendarGlobals['Defaults']['VerticalTimelineTopPadding'];
					
					$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.timeline.begin.tplt', $fv_TemplateVars);
					
					for($year = date("Y", $fv_FirstTime); $year <= date("Y", $fv_LastTime); $year++) {
						if($year == date("Y", $fv_FirstTime)) {
							$monthStart = date("n", $fv_FirstTime);
						} else {
							$monthStart = 1;
						}
						if($year == date("Y", $fv_LastTime)) {
							$monthEnd = date("n", $fv_LastTime);
						} else {
							$monthEnd = 12;
						}
						for($month = $monthStart; $month <= $monthEnd; $month++) {
							$top = (strtotime($year . "-" . $month) - $fv_FirstTime) * $gv_CalendarGlobals['Defaults']['VerticalTimelineScale'] + $gv_CalendarGlobals['Defaults']['VerticalTimelineTopPadding'];
							if($top < $gv_CalendarGlobals['Defaults']['VerticalTimelineTopPadding']) {
								$top = $gv_CalendarGlobals['Defaults']['VerticalTimelineTopPadding'];
							}
							
							$fv_TemplateVars["time_chunk"] = "" . date("Y M", strtotime($year . "-" . $month));
							$fv_TemplateVars["top"] = $top + $gv_CalendarGlobals['Defaults']['VerticalTimelineTextOffset'];
							
							$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.timeline.heading.tplt', $fv_TemplateVars);
						}
					}
					for($i = 0; $i < count($v_rows); $i++) {
						$fv_TemplateVars["top"] = ((strtotime(date("Y-M-d", $v_rows[$i]["mc_date"])) - strtotime(date("Y-M-d", $fv_FirstTime))) * $gv_CalendarGlobals['Defaults']['VerticalTimelineScale']) + $gv_CalendarGlobals['Defaults']['VerticalTimelineTopPadding'];
						$fv_TemplateVars["textTop"] = $fv_TemplateVars["top"] + $gv_CalendarGlobals['Defaults']['VerticalTimelineTextOffset'];
						$fv_TemplateVars["mc_title"] = $v_rows[$i]["mc_title"];
						$fv_TemplateVars["mc_url"] = $v_rows[$i]["mc_url"];
						$fv_TemplateVars["mc_category"] = $v_rows[$i]["mc_category"];
						$fv_TemplateVars["mc_description"] = $v_rows[$i]["mc_description"];
						$fv_TemplateVars["mc_date"] = date("D d", $v_rows[$i]["mc_date"]);
						$fv_TemplateVars["mc_class"] = m_StringToStyleClassName($v_rows[$i]["mc_category"]);
						$fv_TemplateVars["mc_media_class"] = m_StringToStyleClassName($v_rows[$i]["mc_category"]) . "-" . strtolower($v_rows[$i]["mc_media_type"]); // will soft-default to "" if none
						$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.timeline.event-dot.tplt', $fv_TemplateVars);
						if($fv_TemplateVars["mc_url"] == null || $fv_TemplateVars["mc_url"] == "No information") {
							$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.timeline.event-nolink.tplt', $fv_TemplateVars);
						} else {
							$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.timeline.event.tplt', $fv_TemplateVars);
						}
					}
					
					
					$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.timeline.end.tplt', $fv_TemplateVars);
				} else {
					$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.timeline.empty.tplt', $fv_TemplateVars);
				}
				
			break; //timeline_view_vertical
								
			case "delete_event":
				if(!m_permitted($gv_CalendarGlobals['Defaults']['EditorPermissionGroup'])) {
					// User not logged in or lacks permission, prevent them from continuing
					$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.edit-no-perms.tplt', $fv_TemplateVars);
					break;
				}
				
                if ($_REQUEST['t_SelectedCalendarMonth']==$_GET['t_SelectedCalendarMonth'] && $_REQUEST['t_SelectedCalendarDay']==$_GET['t_SelectedCalendarDay'] && $_REQUEST['t_SelectedCalendarYear'] == $_GET['t_SelectedCalendarYear']){
					$v_query = "DELETE FROM molly_calendar WHERE mc_id=" . $_REQUEST['t_CalendarEventID'];
				
					m_DoQuery($v_query);
                    
                    $v_new_location = $fv_TemplateVars['thisPage'] . "?t_CurrentCalendarMode=day_view&t_SelectedCalendarYear=" . $_GET['t_SelectedCalendarYear'] . "&t_SelectedCalendarMonth=" . $_GET['t_SelectedCalendarMonth'] . "&t_SelectedCalendarDay=" . $_GET['t_SelectedCalendarDay']. "&StatusMessage=DeleteSuccess";
				    $fv_TemplateVars['newLocation'] = $v_new_location;
				    $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.delete.tplt', $fv_TemplateVars);

                }
			break; // delete_event
								
			case "add_event":
				if(!m_permitted($gv_CalendarGlobals['Defaults']['EditorPermissionGroup'])) {
					// User not logged in or lacks permission, prevent them from continuing
					$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.edit-no-perms.tplt', $fv_TemplateVars);
					break;
				}
				
				// form not submitted
                if ($_REQUEST['t_SelectedCalendarMonth']==$_GET['t_SelectedCalendarMonth'] && $_REQUEST['t_SelectedCalendarDay']==$_GET['t_SelectedCalendarDay'] && $_REQUEST['t_SelectedCalendarYear'] == $_GET['t_SelectedCalendarYear']){
					if (!isset($_GET['t_submit'])) {
				
						// format date
						$_GET['t_this_date'] = $_GET['t_SelectedCalendarYear'] . "-" . sprintf("%02d", $_GET['t_SelectedCalendarMonth']) . "-" . sprintf("%02d", $_GET['t_SelectedCalendarDay']);

						$fv_TemplateVars['currentDate'] = date("D M d Y", m_MakeUnixTimestampGMT(0,0,0,$_GET['t_SelectedCalendarMonth'],$_GET['t_SelectedCalendarDay'],$_GET['t_SelectedCalendarYear']));
						// drop-downs for the date and time 
				
						$fv_TemplateVars['keyField'] = 't_this_date';
						$fv_TemplateVars['keyValue'] = $_GET['t_this_date'];
					
                        
//                      $editDate;
				
                
                        
				        $fv_TemplateVars['frameColor'] =  $p_FrameColor;
                        $fv_TemplateVars['editDate'] =   date("D M d Y", m_MakeUnixTimestampGMT(0,0,0,$_REQUEST['t_SelectedCalendarMonth'],$_REQUEST['t_SelectedCalendarDay'],$_REQUEST['t_SelectedCalendarYear']));
                        $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.editForm.begin.tplt', $fv_TemplateVars);


						// drop-downs for the date and time 
						for ($v_x=0; $v_x<=23; $v_x++) {
                        $fv_TemplateVars['t_value']= sprintf("%02d", $v_x);
                        $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.editForm.options.tplt', $fv_TemplateVars);

						}
				
					   $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.editForm.hoursEnd.tplt', $fv_TemplateVars);

					
						for ($v_x=0; $v_x<=55; $v_x=$v_x+5) {
                            $fv_TemplateVars['t_value']= sprintf("%02d", $v_x);
                        $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.editForm.options.tplt', $fv_TemplateVars);
						}
				
                        $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.editForm.minEnd.tplt', $fv_TemplateVars);

				
                            foreach ($gv_CalendarGlobals['Categories'] as $v_x) {
                                $fv_TemplateVars['t_value']=  $v_x;
                                    $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.editForm.options.tplt', $fv_TemplateVars);
						      }
                        
                         $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.editForm.catEnd.tplt', $fv_TemplateVars);
                                   foreach ($gv_CalendarGlobals['MediaType'] as $v_x) {
                                $fv_TemplateVars['t_value']=  $v_x;
                                    $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.editForm.options.tplt', $fv_TemplateVars);
						      }
                              
                              $fv_TemplateVars['t_SelectedCalendarYear'] = $_REQUEST['t_SelectedCalendarYear'];
                              $fv_TemplateVars['t_SelectedCalendarMonth'] = $_REQUEST['t_SelectedCalendarMonth'];
                              $fv_TemplateVars['t_SelectedCalendarDay'] = $_REQUEST['t_SelectedCalendarDay'];
                              $fv_TemplateVars['cancelUrl'] = $fv_TemplateVars['thisPage'] . "?t_CurrentCalendarMode=month_view&t_SelectedCalendarYear=" . $_REQUEST['t_SelectedCalendarYear']	. "&t_SelectedCalendarMonth=" . $_REQUEST['t_SelectedCalendarMonth'] .  "&t_SelectedCalendarDay=" . $_REQUEST['t_SelectedCalendarDay'];
                            

                              
                             $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.addForm.end.tplt', $fv_TemplateVars);
               
                        
                        
					} else {
					
						// set up default description
						if ($_GET['t_title'] == "") {
							$_GET['t_title'] = "";
						}
						if ($_GET['t_description'] == "") {
							$_GET['t_description'] = "";
						}
						if ($_GET['t_url'] == "") {
							$_GET['t_url'] = "";
						}
						$addDate=m_MakeUnixTimestampGMT($_GET['hh'],$_GET['mm'],0,$_GET['t_SelectedCalendarMonth'],$_GET['t_SelectedCalendarDay'],$_GET['t_SelectedCalendarYear']);
					
						$v_query = "INSERT INTO molly_calendar (mc_date, mc_title, mc_category, mc_url, mc_media_type, mc_description) VALUES ('".$addDate."','" . $_GET[t_title] . "','" . $_GET[t_category] . "' ,'" . $_GET[t_url] . "' ,'". $_GET[t_mediaType] . "' ,'".rtrim($_REQUEST[t_description], " ")."' )";
						$v_result = m_DoQuery($v_query);

						$v_new_location = $fv_TemplateVars['thisPage'] . "?t_CurrentCalendarMode=day_view&t_SelectedCalendarYear=" . $_GET['t_SelectedCalendarYear'] . "&t_SelectedCalendarMonth=" . $_GET['t_SelectedCalendarMonth'] . "&t_SelectedCalendarDay=" . $_GET['t_SelectedCalendarDay']. "&StatusMessage=AddSuccess";
				        $fv_TemplateVars['newLocation'] = $v_new_location;

                        $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.added.tplt', $fv_TemplateVars);

					}
                }
			break; //add_event
								
			case "edit_event":
				if(!m_permitted($gv_CalendarGlobals['Defaults']['EditorPermissionGroup'])) {
					// User not logged in or lacks permission, prevent them from continuing
					$this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.edit-no-perms.tplt', $fv_TemplateVars);
					break;
				}
				
				$editDate;
				// form not submitted
                if ($_REQUEST['t_SelectedCalendarMonth']==$_GET['t_SelectedCalendarMonth'] && $_REQUEST['t_SelectedCalendarDay']==$_GET['t_SelectedCalendarDay'] && $_REQUEST['t_SelectedCalendarYear'] == $_GET['t_SelectedCalendarYear']){
					if (!$_REQUEST['t_submit']) { //was: if (!isset($_REQUEST['t_submit']))
						foreach ($gv_CalendarGlobals['Categories'] as $v_x) {
							$fv_TemplateVars['categoryOptions'] .= '<option value="' . $v_x .  '">' .  $v_x . '</option>';
						}
                        $v_rows=m_FetchRecordsArray("molly_calendar","*","mc_id=$_REQUEST[t_CalendarEventID]","");
						for($i=0;$i<count($v_rows);$i++){
							$editDate=$v_rows[$i]["mc_date"];
							$v_this_time =explode(":",m_TimeGMT( $v_rows[$i]["mc_date"]));
							$_REQUEST['t_this_date'] = m_DateGMT( $v_rows[$i]["mc_date"]);
							$_REQUEST['t_title'] = htmlspecialchars($v_rows[$i]["mc_title"]);
							$_REQUEST['t_description'] = htmlspecialchars($v_rows[$i]["mc_description"]);
                            $_REQUEST['t_category'] = htmlspecialchars($v_rows[$i]["mc_category"]);
                            $_REQUEST['t_mediaType'] = htmlspecialchars($v_rows[$i]["mc_media_type"]);

                            $_REQUEST['t_url'] = htmlspecialchars($v_rows[$i]["mc_url"]);

							$hh = $v_this_time[0];
							$mm = $v_this_time[1];
				
						}
                        
				        $fv_TemplateVars['frameColor'] =  $p_FrameColor;
                        $fv_TemplateVars['editDate'] =   date("D M d Y", m_MakeUnixTimestampGMT(0,0,0,$_REQUEST['t_SelectedCalendarMonth'],$_REQUEST['t_SelectedCalendarDay'],$_REQUEST['t_SelectedCalendarYear']));
                        $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.editForm.begin.tplt', $fv_TemplateVars);

				
						// drop-downs for the date and time 
						for ($v_x=0; $v_x<=23; $v_x++) {
                        $fv_TemplateVars['t_value']= sprintf("%02d", $v_x);
							if (sprintf("%20d", $v_x) == $hh) {
                            $fv_TemplateVars['selected']= "selected";
                            } else {
                            $fv_TemplateVars['selected']= "";
                            }
                        $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.editForm.options.tplt', $fv_TemplateVars);

						}
				
					   $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.editForm.hoursEnd.tplt', $fv_TemplateVars);

					
						for ($v_x=0; $v_x<=55; $v_x=$v_x+5) {
                            $fv_TemplateVars['t_value']= sprintf("%02d", $v_x);
							if (sprintf("%20d", $v_x) == $hh) {
                            $fv_TemplateVars['selected']= "selected";
                            } else {
                            $fv_TemplateVars['selected']= "";
                            }
                        $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.editForm.options.tplt', $fv_TemplateVars);
						}
				
                        $fv_TemplateVars['t_title'] = $_REQUEST['t_title'];
                        $fv_TemplateVars['t_description'] = $_REQUEST['t_description'];
                        $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.editForm.minEnd.tplt', $fv_TemplateVars);

				
                            foreach ($gv_CalendarGlobals['Categories'] as $v_x) {
                                $fv_TemplateVars['t_value' ]=  $v_x;
							     if ( $v_x == $_REQUEST['t_category']) {
                                    $fv_TemplateVars['selected']= "selected";
                                    } else {
                                    $fv_TemplateVars['selected']= "";
                                    }
                                    $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.editForm.options.tplt', $fv_TemplateVars);
						      }
                        
                         $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.editForm.catEnd.tplt', $fv_TemplateVars);
                                   foreach ($gv_CalendarGlobals['MediaType'] as $v_x) {
                                $fv_TemplateVars['t_value']=  $v_x;
							     if ( $v_x == $_REQUEST['t_mediaType']) {
                                    $fv_TemplateVars['selected']= "selected";
                                    } else {
                                    $fv_TemplateVars['selected']= "";
                                    }
                                    $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.editForm.options.tplt', $fv_TemplateVars);
						      }
                  

                              $fv_TemplateVars['t_url'] = $_REQUEST['t_url'];
                              $fv_TemplateVars['t_CalendarEventID'] = $_REQUEST['t_CalendarEventID'];
                              $fv_TemplateVars['t_SelectedCalendarYear'] = $_REQUEST['t_SelectedCalendarYear'];
                              $fv_TemplateVars['t_SelectedCalendarMonth'] = $_REQUEST['t_SelectedCalendarMonth'];
                              $fv_TemplateVars['t_SelectedCalendarDay'] = $_REQUEST['t_SelectedCalendarDay'];
                              $fv_TemplateVars['cancelUrl'] = $fv_TemplateVars['thisPage'] . "?t_CurrentCalendarMode=month_view&t_SelectedCalendarYear=" . $_REQUEST['t_SelectedCalendarYear']	. "&t_SelectedCalendarMonth=" . $_REQUEST['t_SelectedCalendarMonth'] .  "&t_SelectedCalendarDay=" . $_REQUEST['t_SelectedCalendarDay'];
                              
   
                             $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.editForm.end.tplt', $fv_TemplateVars);

                        	
				
					} else {
						global $hh, $mm;
						$hh=$_REQUEST[hh];
						$mm=$_REQUEST[mm];
						// format time
						$v_this_time = m_MakeUnixTimestampGMT($hh,$mm,"00", $_REQUEST['t_SelectedCalendarMonth'],$_REQUEST['t_SelectedCalendarDay'],$_REQUEST['t_SelectedCalendarYear']);
						// set up default description
						if ($v_title == "") { $v_title = ""; }
						if ($v_description == "") { $v_description = ""; }
                        if ($v_url == "") { $v_url = ""; }
				
						$v_query = "UPDATE molly_calendar SET mc_date='$v_this_time' , mc_title='" . $_REQUEST['t_title'] . "', mc_category='" . $_REQUEST['t_category'] . "',mc_url='" . $_REQUEST['t_url'] . "',mc_media_type='" . $_REQUEST['t_mediaType'] ."',mc_description='" . rtrim($_REQUEST['t_description'], " "). "' WHERE mc_id='" . $_REQUEST['t_CalendarEventID']."'";
				
						$v_result = m_DoQuery($v_query);
	
						$v_new_location = $fv_TemplateVars['thisPage'] . "?t_CurrentCalendarMode=day_view&t_SelectedCalendarYear=" . $_REQUEST['t_SelectedCalendarYear'] . "&t_SelectedCalendarMonth=" . $_REQUEST['t_SelectedCalendarMonth'] . "&t_SelectedCalendarDay=" . $_REQUEST['t_SelectedCalendarDay'] . "&StatusMessage=EditSuccess";
				
                        $fv_TemplateVars['newLocation'] = $v_new_location;

                        $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.editForm.editAlert.tplt', $fv_TemplateVars);

					}
				}
			break; //edit_event
								
			default:
                $this->echoTemplate($gv_CalendarDirectory . 'templates/calendar.default.tplt', $fv_TemplateVars);
			break;
		}
		$fv_TemplateVars['CategoryStyles'] = $gv_CategoryStyles;
        $fv_TemplateVars['MediaStyles'] = $gv_MediaStyles;

		$fv_TheTemplate = $this->fetchTemplate($gv_CalendarDirectory . 'templates/calendar.style.tplt');
		$fv_TheTemplate = m_Interpolate($fv_TheTemplate, $fv_TemplateVars);
		
		m_AppendStylesheet($fv_TheTemplate, 'calendar', FALSE);

	}
    function m_NumWeeksInMonth($monthNum){
        // CHECK TO SEE HOW MANY WEEKS IN CURRENT MONTH
        		global $g_NumDaysinEachMonth;

                   $v_dayCount=1;
                $v_dayArray=array();
                while ($v_dayCount <= $g_NumDaysinEachMonth[$monthNum]) {
                    $v_dayOfWeek = date("w", m_MakeUnixTimestampGMT(0,0,0,$monthNum,$v_dayCount,$_REQUEST['t_SelectedCalendarYear']));
                    $v_dayArray[] = $v_dayOfWeek;
				    $v_dayCount++;
                }
                $days_count = array_count_values($v_dayArray);
                $num_of_6s = $days_count[6]; 
                $oldSunday=0;
                $weeks=0;
                for ($num6=1; $num6<=$num_of_6s; $num6++) {
                    $sunday= array_search("6",$v_dayArray);
                    $daysInWeek = $sunday-$oldSunday +1;
                    $v_dayArray= array_slice($v_dayArray,$sunday+1);
                    $weeks++;
                }                
                $v_dayArray = array_filter($v_dayArray);
                   if (!empty($v_dayArray)) {
                    $weeks++;
                }
                    
        return $weeks;
      //  return "REACHED";
    }

}
?>